//	Pickup.cpp - Base class for all Pickups.
//  ----------------------------------------------------------------------------
//	This file is part of 'GameTemplate', template code for a game.
//	Copyright (C) 2011  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "Pickup.h"
#include "drawing/Drawer.h"

//------------------------------------------------------------------------------
Pickup::Pickup(const std::wstring& pickupName):
name(pickupName)
{

}

//------------------------------------------------------------------------------
Pickup::~Pickup()
{
	TonePtr t = tone.lock();
	if(t)
		t->setPickup(PickupPtr());
}

//------------------------------------------------------------------------------
void Pickup::draw(DrawerPtr& d, float timestepInterp)
{
	d->drawImage(L"dot", position-64, TwoFloats(1.0f), ThreeFloats(0.2f));
	d->drawImage(getIcon(), position-64);

	d->drawText(name,
				L"Font1",
				textLayout,
				TwoFloats(position.x-128.0f, position.y-34.0f),
				256.0f,
				TextLayout::Centre,
				1.0f,
				ThreeFloats(0.5f));
}

//------------------------------------------------------------------------------
void Pickup::setPosition(const TwoFloats& pos)
{
	position = pos;
}

//------------------------------------------------------------------------------
void Pickup::setTone(TonePtr t)
{
	if(!t)
		tone.reset();
	tone = t;
}
